unit main_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, XPMan,jpeg, ExtDlgs, ComCtrls,

  service_u,bmp_u,selection_u,sprite_u,sprite_list_u;


type
  Tmain_f = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    file_open1: TMenuItem;
    N1: TMenuItem;
    file_save_under1: TMenuItem;
    file_exit1: TMenuItem;
    XPManifest1: TXPManifest;
    pctrl: TPageControl;
    selection_ts: TTabSheet;
    control_ts: TTabSheet;
    selection_to_sprite_chb: TCheckBox;
    edit1: TMenuItem;
    edit_delete1: TMenuItem;
    sprite_merge_style_p: TPanel;
    sprite_top_p: TPanel;
    sprite_b_p: TPanel;
    lb_del_b: TButton;
    lb_down_b: TButton;
    lb_up_b: TButton;
    Label4: TLabel;
    sprite_merge_style_cb: TComboBox;
    Label5: TLabel;
    sprite_transparency_sb: TScrollBar;
    sprite_lb: TListBox;
    open_pic_dlg: TOpenPictureDialog;
    back_p: TPanel;
    paint_border_p: TPanel;
    paintbox: TPaintBox;
    save_pic_dlg: TSavePictureDialog;
    file_save1: TMenuItem;
    edit_copy1: TMenuItem;
    edit_paste1: TMenuItem;
    help1: TMenuItem;
    about1: TMenuItem;
    selection_m: TMemo;
    selection_merge_style_p: TPanel;
    Label2: TLabel;
    selection_merge_style_cb: TComboBox;
    selection_transparency_sb: TScrollBar;
    Label3: TLabel;
    selection_style_p: TPanel;
    Label1: TLabel;
    selection_style_rectangle_rb: TRadioButton;
    selection_style_ellipse_rb: TRadioButton;
    selection_style_freestyle_rb: TRadioButton;
    selection_src_p: TPanel;
    Label6: TLabel;
    selection_src_org_rb: TRadioButton;
    selection_src_cur_rb: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure paintboxPaint(Sender: TObject);
    procedure file_exit1Click(Sender: TObject);
    procedure paintboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure paintboxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure paintboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure selection_merge_style_cbChange(Sender: TObject);
    procedure paintboxDblClick(Sender: TObject);
    procedure pctrlChange(Sender: TObject);
    procedure sprite_lbClick(Sender: TObject);
    procedure sprite_merge_style_cbChange(Sender: TObject);
    procedure lb_del_bClick(Sender: TObject);
    procedure lb_down_bClick(Sender: TObject);
    procedure lb_up_bClick(Sender: TObject);
    procedure file_open1Click(Sender: TObject);
    procedure file_save_under1Click(Sender: TObject);
    procedure about1Click(Sender: TObject);
    procedure file_save1Click(Sender: TObject);
    procedure edit_copy1Click(Sender: TObject);
    procedure edit_paste1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    homedir:string;
    afn:string;

    //defined transparent color
    transp_rgbcol:trgbcol;

    //clear original pic
    pic_bmp:tbmp;

    //preview pic (with border-rectangles)
    preview_bmp:tbmp;

    //bitmap of paintbox
    pb_bmp:tbmp;

    //sprite-paint bitmnap
    sprite_bmp:tbmp;

    //sprite id counter
    sprite_c:integer;

    //current mouse coodinates
    mouse_down_ok:bool;

    //coordinates left-top pixel of preview on paintbox
    preview_left,preview_top:integer;

    selection:tselection;

    //sprite-painter-pic-format for clipboard
    spp_clipboard_format:cardinal;

    //freestyle selection params
    freestyle_c:integer;
    freestyle_a:array[0.._freestyle_max]of tpoint;


    procedure pic_load(fn:string);
    procedure pic_save(fn:string);

    procedure stream_load(strm:tstream);
    procedure stream_save(strm:tstream);

    procedure pb_update(border_ok:bool);

    procedure cursor_set(cr:tcursor);
    function is_transp_rgbcol(rgbcol:trgbcol):bool;
  end;

var
  main_f: Tmain_f;

implementation

{$R *.dfm}

procedure Tmain_f.FormCreate(Sender: TObject);
begin
  homedir:=extractfilepath(application.ExeName);
  caption:=_caption;

  //needed bitmaps
  pic_bmp:=tbmp.create;pic_bmp.Modified:=false;
  preview_bmp:=tbmp.create;
  pb_bmp:=tbmp.create;
  sprite_bmp:=tbmp.create;

  //one instance of selection class
  selection:=tselection.create;

  //define transparent color
  transp_rgbcol:=service_u.col2rgbcol(
    rgb(_transp_col_r,_transp_col_g,_transp_col_b)
  );
  sprite_c:=0;

  //define sprite-painter-pic-format for clipboard
  spp_clipboard_format:=RegisterClipboardFormat(
    PChar('SPRITE-PAINTER-PIC')
  );

  //desgin
  color:=_background_color;
  sprite_top_p.ParentBackground:=false;
  sprite_lb.align:=alclient;
  back_p.align:=alclient;
  paint_border_p.align:=alclient;
  paint_border_p.ParentBackground:=false;
  paint_border_p.color:=_background_color;
  paintbox.Align:=alclient;
  pctrl.ActivePage:=selection_ts;
end;

procedure Tmain_f.FormDestroy(Sender: TObject);
begin
  sprite_bmp.Free;
  pb_bmp.Free;
  preview_bmp.Free;
  pic_bmp.Free;
end;

procedure Tmain_f.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if pic_bmp.Modified then begin
    if application.MessageBox(
      'Picture modified. Close without saving?',
      'Question',
      mb_yesno
    )=id_no then canclose:=false;
  end;
end;

procedure tmain_f.stream_load(strm:tstream);
var
  header:string;
begin
  //header
  header:=service_u.stream_tag_section_read(strm,'header');
  sprite_c:=service_u.string_tag_int(header,'sprite_c',sprite_c);

  //background
  service_u.stream_tag_section_read(strm,'size');
  pic_bmp.LoadFromStream(strm);

  //and list of sprites
  sprite_list_u.stream_load(strm);
end;

procedure tmain_f.pic_load(fn:string);
var
  jpg:tjpegimage;
  fstrm:tfilestream;
  pb_w,pb_h:integer;
  w,h:integer;
  ext:string;
begin
  screen.Cursor:=crhourglass;
  try
    //clear selection and list of sprites
    selection.clear;
    sprite_list_u.clear;

    //get pic-format
    ext:=ansilowercase(extractfileext(fn));
    if(ext='.jpg')or(ext='.jpeg')or(ext='.jpe')then begin
      jpg:=tjpegimage.Create;
      try
        jpg.LoadFromFile(fn);
        pic_bmp.assign(jpg);
      finally
        jpg.Free;
      end;
    end
    else if ext='.bmp' then begin
      pic_bmp.LoadFromFile(fn);
    end
    else if ext='.spp' then begin
      fStrm:=TfileStream.Create(fn,fmopenread);
      try
        stream_load(fstrm);
      finally
        fstrm.Free;
      end;
    end
    else begin
      application.MessageBox('Unknown Extenson','DIRTY ERROR',mb_ok);
      exit;
    end;

    //adapt size to paintbox
    pb_w:=paintbox.Width;
    pb_h:=paintbox.height;
    if(pic_bmp.width/pb_w)>(pic_bmp.Height/pb_h) then begin
      w:=pb_w;
      h:=trunc(w*pic_bmp.Height/pic_bmp.width);
    end
    else begin
      h:=pb_h;
      w:=trunc(h*pic_bmp.width/pic_bmp.height);
    end;
    preview_bmp.size_set(w,h);

    //paint original pic to preview_bmp
    SetStretchBltMode(preview_bmp.Canvas.handle,coloroncolor);
    stretchblt(
      preview_bmp.Canvas.Handle,0,0,w,h,
      pic_bmp.Canvas.Handle,0,0,pic_bmp.width,pic_bmp.Height,
      srccopy
    );

    //save this "clear" preview_bmp back in pic_bmp
    pic_bmp.assign(preview_bmp);

    //set size og sprite-paint-bmp
    sprite_bmp.size_set(w,h);

    afn:=fn;caption:=_caption+' - '+afn;
    pic_bmp.Modified:=false;

    //show the pic
    pb_update(true);
  finally
    screen.cursor:=crdefault;
  end;
end;

procedure Tmain_f.file_open1Click(Sender: TObject);
begin
  if pic_bmp.modified then begin
    if application.MessageBox(
      'Picture modified. Continue?',
      'Question',
      mb_yesno
    )=id_no then exit;;
  end;
  if not open_pic_dlg.execute then exit;
  pic_load(open_pic_dlg.FileName);
end;

procedure tmain_f.stream_save(strm:tstream);
var
  mstrm:tmemorystream;
begin
  //header infos
  service_u.stream_write(strm,'<sprite_painter>');
  service_u.stream_write(strm,'<header>');
  service_u.stream_write(strm,'<author>daniel schwamm</author>');
  service_u.stream_write(strm,'<url>http://www.henrys.de/daniel</url>');
  service_u.stream_write(strm,'<sprite_c>'+inttostr(sprite_c)+'</sprite_c>');
  service_u.stream_write(strm,'</header>');

  //background
  mstrm:=tmemorystream.create;
  try
    service_u.stream_write(strm,'<pic_bmp>');
    pic_bmp.SaveToStream(mstrm);
    service_u.stream_write(strm,'<size>'+inttostr(mstrm.size)+'</size>');
    mstrm.SaveToStream(strm);
  finally
    mstrm.Free;
  end;

  //and list of sprites
  sprite_list_u.stream_save(strm);
end;

procedure tmain_f.pic_save(fn:string);
var
  jpg:tjpegimage;
  fstrm:tfilestream;
  ext:string;
begin
  if pic_bmp.Empty then exit;
  
  screen.cursor:=crhourglass;
  try
    //get pic-format
    ext:=ansilowercase(extractfileext(fn));
    if(ext='.jpg')or(ext='.jpeg')or(ext='.jpe')then begin
      //create clear preview without borders
      pb_update(false);

      //save preview as jpg
      jpg:=tjpegimage.Create;
      try
        jpg.assign(preview_bmp);
        jpg.SaveToFile(fn);
      finally
        jpg.free;
      end;
    end
    else if ext='.bmp' then begin
      //create clear preview without borders
      pb_update(false);
      preview_bmp.SaveToFile(fn);
    end
    else begin
      //load pic as filestream
      fStrm:=TfileStream.Create(fn,fmCreate);
      try
        stream_save(fstrm);
      finally
        fstrm.Free;
      end;
    end;

    afn:=fn;caption:=_caption+' - '+afn;
    pic_bmp.Modified:=false;

    //show then pic
    pb_update(true);
  finally
    screen.cursor:=crdefault;
  end;
end;

procedure Tmain_f.file_save_under1Click(Sender: TObject);
var
  fn,ext:string;
begin
  //put filename into svae_pic_dlg without extension
  ext:=ansilowercase(extractfileext(afn));
  fn:=copy(afn,1,length(afn)-length(ext));
  save_pic_dlg.filename:=fn;
  if not save_pic_dlg.Execute then exit;

  //get chosen pic-format, append extension
  fn:=save_pic_dlg.filename;
  ext:=ansilowercase(extractfileext(fn));
  if ext='' then begin
    if      save_pic_dlg.FilterIndex=2 then ext:='.jpg'
    else if save_pic_dlg.FilterIndex=3 then ext:='.bmp'
    else                                    ext:='.spp';
    fn:=fn+ext;
  end;

  pic_save(fn);
end;

procedure Tmain_f.file_save1Click(Sender: TObject);
begin
  pic_save(afn);
end;

procedure Tmain_f.file_exit1Click(Sender: TObject);
begin
  close;
end;

procedure Tmain_f.paintboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  sprite:tsprite;
begin
  if afn='' then exit;

  mouse_down_ok:=true;
  if pctrl.activepage=selection_ts then begin
    //selection-mode
    selection.MouseDown(button,shift,x-preview_left,y-preview_top);
  end
  else begin
    //sprite-mode
    //any sprite selected?
    sprite:=sprite_list_u.sprite_active;if sprite=nil then exit;
    //yep
    sprite.MouseDown(button,shift,x-preview_left,y-preview_top);
  end;
end;

procedure Tmain_f.paintboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  sprite:tsprite;
begin
  //no file, no action
  if afn='' then exit;

  if pctrl.activepage=selection_ts then begin
    selection.Mousemove(shift,x-preview_left,y-preview_top);
  end
  else begin
    sprite:=sprite_list_u.sprite_active;if sprite=nil then exit;
    sprite.Mousemove(shift,x-preview_left,y-preview_top);
  end;
end;

procedure Tmain_f.paintboxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  sprite:tsprite;
begin
  if afn='' then exit;
  if not mouse_down_ok then exit;

  mouse_down_ok:=false;
  if pctrl.activepage=selection_ts then begin
    selection.MouseUp(button,shift,x-preview_left,y-preview_top);
  end
  else begin
    sprite:=sprite_list_u.sprite_active;if sprite=nil then exit;
    sprite.MouseUp(button,shift,x-preview_left,y-preview_top);
  end;
end;

//this function set cursor an update immediately
procedure tmain_f.cursor_set(cr:tcursor);
begin
  cursor:=cr;
  Perform(WM_SETCURSOR,Handle,HTCLIENT);
end;

//check if color is our defined transprent color
function tmain_f.is_transp_rgbcol(rgbcol:trgbcol):bool;
begin
  result:=
    (rgbcol.r=transp_rgbcol.r)and
    (rgbcol.g=transp_rgbcol.g)and
    (rgbcol.b=transp_rgbcol.b);
end;

//one or more proporties of selection has changed
procedure Tmain_f.selection_merge_style_cbChange(Sender: TObject);
begin
  selection.merge_style:=tmerge_style(selection_merge_style_cb.ItemIndex);
  selection.transparency:=selection_transparency_sb.Position;
  pb_update(true);
end;

procedure Tmain_f.paintboxDblClick(Sender: TObject);
begin
  if afn='' then exit;
  //doubleclick handled only by selection (not sprites)
  if pctrl.activepage=selection_ts then selection.dblclick;
end;

procedure Tmain_f.pctrlChange(Sender: TObject);
begin
  //edit-menu enabled only in sprite-mode
  edit1.Enabled:=(pctrl.activepage=control_ts);
  pb_update(true);
end;

procedure Tmain_f.sprite_lbClick(Sender: TObject);
var
  sprite:tsprite;
begin
  //is there any active sprite?
  sprite:=sprite_list_u.sprite_active;if sprite=nil then exit;

  //get properties of sprite
  sprite_merge_style_cb.ItemIndex:=integer(sprite.merge_style);
  sprite_transparency_sb.position:=sprite.transparency;
  pb_update(true);
end;

//one or more properties of active sprite has changed
procedure Tmain_f.sprite_merge_style_cbChange(Sender: TObject);
var
  sprite:tsprite;
begin
  sprite:=sprite_list_u.sprite_active;if sprite=nil then exit;
  sprite.merge_style:=tmerge_style(sprite_merge_style_cb.ItemIndex);
  sprite.transparency:=sprite_transparency_sb.position;
  pb_update(true);
end;

procedure Tmain_f.lb_del_bClick(Sender: TObject);
begin
  sprite_list_u.delete_active;
end;

procedure Tmain_f.lb_down_bClick(Sender: TObject);
begin
  sprite_list_u.down;
end;

procedure Tmain_f.lb_up_bClick(Sender: TObject);
begin
  sprite_list_u.up;
end;

procedure Tmain_f.edit_copy1Click(Sender: TObject);
begin
  sprite_list_u.clipboard_copy;
end;

procedure Tmain_f.edit_paste1Click(Sender: TObject);
begin
  sprite_list_u.clipboard_paste;
end;

procedure Tmain_f.about1Click(Sender: TObject);
begin
  application.MessageBox(
    pchar(
     ansiuppercase(_caption)+_cr+_cr+
     'November 2009'+_cr+
     'Daniel Schwamm'+_cr+_cr+
     'http://www.henrys.de/daniel'
    ),
    'About',
    mb_ok
  );
end;

procedure Tmain_f.paintboxPaint(Sender: TObject);
begin
  if afn='' then exit;
  //copy prepared pb_bmp to paintbox-canvas
  bitblt(
    paintbox.Canvas.Handle,0,0,paintbox.width,paintbox.height,
    pb_bmp.canvas.Handle,0,0,
    srccopy
  );
end;

//-----------------------------------------------------------------------
//kernel procedure: making of preview_bmp
//
//pic_bmp + sprites + selection painted on preview_bmp
//
//preview_bmp centered on pb_bmp
//
//pb_bmp painted on paintbox-canvas
//
//-----------------------------------------------------------------------
procedure tmain_f.pb_update(border_ok:bool);
var
  pb_h,pb_w,w,h:integer;
  x,y:integer;
  r:integer;
  rgbcol:trgbcol;
  hit_ok:bool;
  selection_ok:bool;
  sprite_max:integer;
  sprite_a:array[0.._sprite_max]of tsprite;
  sprite:tsprite;
begin
  //selection mode (or sprite.mode)?
  selection_ok:=(pctrl.ActivePage=selection_ts);

  //must save spritelist-params in "fixed" vars
  //cause that speed up the procedure enormously
  sprite_max:=sprite_list_u.count;
  for r:=0 to sprite_max-1 do begin
    sprite_a[r]:=sprite_list_u.sprite_get(r);
  end;

  //filling all pixels of preview_bmp
  for y:=0 to preview_bmp.height-1 do begin
    //get line of pixels from ...
    preview_bmp.ba_set(y);
    pic_bmp.ba_set(y);

    for x:=0 to preview_bmp.width-1 do begin
      //get current pixel from original
      rgbcol:=pic_bmp.rgbcol_get(x);

      //merge color with sprite-pixel at same position
      //the last sprite dominates
      //pixel can be transparent, so we must check all sprites!
      for r:=0 to sprite_max-1 do begin
        rgbcol:=sprite_a[r].merge_rgbcol(rgbcol,x,y,hit_ok);
      end;

      //selection pixel at same position?
      //the selection is always 'higher' as sprites
      if selection_ok then rgbcol:=selection.merge_rgbcol(rgbcol,x,y,hit_ok);

      //set calculated preview pixel
      preview_bmp.rgbcol_set(x,rgbcol);
    end;
  end;

  //any border-recs allowed on preview_bmp?
  if border_ok then begin
    //yep
    if selection_ok then begin
      selection.border;
    end
    else begin
      //any active sprite?
      sprite:=sprite_list_u.sprite_active;
      if sprite<>nil then sprite.border;
    end;
  end;

  //now paint preview_bmp centered on pb_bmp
  pb_w:=paintbox.Width;
  pb_h:=paintbox.height;

  w:=preview_bmp.Width;
  h:=preview_bmp.height;

  preview_left:=(pb_w-w)div 2;
  preview_top:=(pb_h-h)div 2;

  pb_bmp.size_set(pb_w,pb_h);
  pb_bmp.fill_col(_background_color);

  bitblt(
    pb_bmp.Canvas.Handle,preview_left,preview_top,w,h,
    preview_bmp.canvas.Handle,0,0,
    srccopy
  );

  //draw pb_bmp on paintbox-cancas
  paintboxPaint(nil);
end;


end.

