unit sprite_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, XPMan,jpeg,math,

  service_u,bmp_u,selection_u;

type
  tsprite=class(tselection)
    name:string;

    constructor create;
    procedure assign(selection:tselection);

    procedure stream_load(strm:tstream);
    procedure stream_save(strm:tstream);
  end;

implementation

uses main_u;

constructor tsprite.create;
begin
  inherited;
  range_ok:=true;
  border_outer_col:=clteal;
  border_inner_col:=cllime;
end;

procedure tsprite.assign(selection:tselection);
begin
  main_f.sprite_bmp.rec_no_rgbcol_count(main_f.transp_rgbcol,rec);
  bmp.size_set(rec.right-rec.Left,rec.bottom-rec.top);
  bitblt(
    bmp.Canvas.Handle,0,0,bmp.width,bmp.Height,
    main_f.sprite_bmp.canvas.Handle,rec.left,rec.Top,
    srccopy
  );
  org_bmp.assign(bmp);
  transparency:=selection.transparency;
  merge_style:=selection.merge_style;
end;

procedure tsprite.stream_load(strm:tstream);
var
  s:string;
begin
  s:=service_u.stream_tag_section_read(strm,'header');

  name:=service_u.string_tag(s,'name',name);

  transparency:=service_u.string_tag_int(s,'transparency',transparency);
  merge_style:=tmerge_style(service_u.string_tag_int(s,'merge_style',integer(merge_style)));

  rec.left:=service_u.string_tag_int(s,'rec_left',rec.left);
  rec.top:=service_u.string_tag_int(s,'rec_top',rec.top);
  rec.right:=service_u.string_tag_int(s,'rec_right',rec.right);
  rec.bottom:=service_u.string_tag_int(s,'rec_bottom',rec.bottom);

  //org_bmp
  s:=service_u.stream_tag_section_read(strm,'size');
  org_bmp.LoadFromStream(strm);

  rec_set(rec);
end;

procedure tsprite.stream_save(strm:tstream);
var
  mstrm:tmemorystream;
begin
  mstrm:=tmemorystream.create;
  try
    service_u.stream_write(strm,'<sprite>');

    service_u.stream_write(strm,'<header>');
    service_u.stream_write(strm,'<name>'+name+'</name>');
    service_u.stream_write(strm,'<transparency>'+inttostr(transparency)+'</transparency>');
    service_u.stream_write(strm,'<merge_style>'+inttostr(integer(merge_style))+'</merge_style>');
    service_u.stream_write(strm,'<rec_top>'+inttostr(rec.top)+'</rec_top>');
    service_u.stream_write(strm,'<rec_left>'+inttostr(rec.left)+'</rec_left>');
    service_u.stream_write(strm,'<rec_right>'+inttostr(rec.right)+'</rec_right>');
    service_u.stream_write(strm,'<rec_bottom>'+inttostr(rec.bottom)+'</rec_bottom>');
    service_u.stream_write(strm,'</header>');

    service_u.stream_write(strm,'<org_bmp>');
    org_bmp.SaveToStream(mstrm);
    service_u.stream_write(strm,'<size>'+inttostr(mstrm.size)+'</size>');
    mstrm.SaveToStream(strm);
  finally
    mstrm.Free;
  end;
end;

end.

